/* begincopyright
  Copyright (c) 1988 Xerox Corporation. All rights reserved.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted. Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws. This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification. Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    PCR Coordinator
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
  endcopyright */

/*
 * CirioNubInnerProcs.h
 *
 * Demers, February 25, 1992 11:33:54 am PSTPST
 *
 * CirioNub shared (local/server) procedure descriptions.
 *
 * These procedures never lock the load state.
 */

#ifndef _CIRIO_NUB_INNER_PROCS_
#define _CIRIO_NUB_INNER_PROCS_

#ifndef _CIRIO_NUB_TYPES_
#   include "xr/CirioNubTypes.h"
#endif




extern int
CirioNubInnerGetThread(/* int index, CirioNubThreadData buf */);
/*
    Get data about thread whose index is abs(index).
    Return 0 on success, (-1) on failure
            (abs(index) out of range, or ((index > 0) && (thread inactive))).
*/


extern int
CirioNubInerPCtoInfo(/* XR_Pointer pc, CirioNubPCInfo buf */);
/*
    Map absolute pc to info.
    Return 0 on success, (-1) on failure.
*/

/*
 * For the following procs, consult IncrementalLoad.h
 */


extern int
CirioNubInnerGetFileEntry(/* unsigned seqNum, CirioNubFileEntry buf */);
/*
    Get file entry with largest seqNum <= the specified one.
    Return 0 (Claim: can't fail).
*/


extern int
CirioNubInnerGetMatchingSymEntryByName(/*
    unsigned symID,
    char *pattern,
    bool caseSensitive,
    unsigned wantedTypes,
    unsigned ignoredClasses,
    int numToSkip,
    CirioNubSymEntry buf
*/);
/*
    Like XR_ILGetMatchingSymEntryByName.
    Returns 0 on success, (-1) on failure.
*/


extern int
CirioNubInnerGetMatchingSymEntryByValue(/*
    unsigned symID,
    unsigned val,
    unsigned wantedTypes,
    unsigned ignoredClasses,
    int numToSkip,
    CirioNubSymEntry buf
*/);
/*
    Like XR_ILGetMatchingSymEntryByValue.
    Returns 0 on success, (-1) on failure.
*/

#ifdef UNDEFINED
/* OBSOLETE: */

extern int
CirioNubInnerSkipSymEntryByName(/*
    unsigned symID,
    bool caseSensitive,
    bool externOnly,
    int numToSkip,
    CirioNubSymEntry buf
*/);
/*
    Skip forward/backward specified number of symbols by name.
    Return 0 on success, (-1) on failure.
*/

extern int
CirioNubInnerSkipSymEntryByValue(/*
    unsigned symID,
    int numToSkip,
    CirioNubSymEntry buf
*/);
/*
    Skip forward/backward specified number of symbols by value.
    Return 0 on success, (-1) on failure.
*/
#endif


extern int
CirioNubInnerGetInstrSetAndOpSys(/*
    CirioNubInstrSetAndOpSys buf
*/);
/*
    Identify this machine's instruction set name and operating system name.
    Return 0 on success, (-1) on failure.
*/

#endif /* _CIRIO_NUB_INNER_PROCS_ */

